# Copyright 2008, LEDAS

# NO PART OF THIS SOFTWARE MAY BE RE-USED FOR ANY OTHER PURPOSE THAN TO RUN
# DRIVING DIMENSIONS WITHOUT THE EXPRESS AND WRITTEN APPROVAL OF LEDAS.


# YOU UNDERSTAND AND AGREE THAT LEDAS IS MAKING NO WARRANTY THAT THE SOFTWARE WILL
# MEET YOUR REQUIREMENTS, THAT THE SOFTWARE WILL BE ERROR OR BUG-FREE,
# REGARDING THE SECURITY, RELIABILITY OR PERFORMANCE OF THE SOFTWARE, OR THAT ANY
# ERRORS IN THE SOFTWARE WILL BE CORRECTED.  YOUR USE OF THE SOFTWARE IS AT YOUR SOLE RISK.
# THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND WITHOUT WARRANTY OF ANY KIND.
# TO THE EXTENT PERMITTED BY LAW, LEDAS DISCLAIMS ALL WARRANTIES AND CONDITIONS OF ANY KIND,
# WHETHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES AND CONDITIONS
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT. ANY CONTENT 
# OR MATERIAL DOWNLOADED OR OTHERWISE OBTAINED THROUGH THE USE OF THE SOTWARE IS DONE AT
# YOUR OWN DISCRETION AND RISK AND YOU WILL BE SOLELY RESPONSIBLE FOR ANY DAMAGE TO YOUR
# COMPUTER SYSTEM OR OTHER DEVICE OR LOSS OF DATA THAT RESULTS FROM THE DOWNLOAD OF ANY
# SUCH CONTENT OR MATERIAL.  YOU CAN RECOVER FROM LEDAS AND ITS SUPPLIERS ONLY DIRECT DAMAGES
# UP TO THE AMOUNT YOU PAID FOR THE SOFTWARE.  YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING
# CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT OR INCIDENTAL DAMAGES.



require 'sketchup.rb'

require "ldd\\ldd_tool.rb"
require "ldd\\ldd_fixation_tool.rb"
require "ldd\\ldd_sketchup_classes.rb"
require "ldd\\ldd_common_functions.rb"

require 'LangHandler.rb'

include LDD


$lddStrings = LanguageHandler.new("ldd.strings")

#===============================================================================================



LEDAS_DRIVING_DIMENSIONS_VERSION = 0.3

LEDAS_DRIVING_DIMENSIONS_BUILD = 507

release_time = Time.gm(2008, 12,23,12,00,0)

#===============================================================================================

if ((release_time + 60*60*24*30*3 <=> Time.new) == -1)

  dlg1 = UI::WebDialog.new("Obsolete Version", false, "Units Picker", 600, 400, 350, 250, false);
  
  image1 = Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_tool.bmp"
    
   html_string1 =
    "<html> 
    <head> 
      <title> Obsolete Driving Dimensions</title>
    </head>
    <body  bgcolor =	D4D0C8> 
       <p> <center> <img src=\" "+ image1 +"\"  alt=\"Picture\"> </center> </p>
       <p> <center> <b>  <big> <big> Driving Dimensions  </big> </big> </b> </center> </p>
       <p> <center> <b>  <big> <big> Obsolete Version  </big> </big> </b> </center> </p>
       <center> Your version of Driving Dimensions plug-in seems to be obsolete. </center>
       <p> <center> Please go to <a href=\"http://drivingdimensions.com\" target= \"_blank\"> 
                                    www.DrivingDimensions.com </a> to check for the latest version. </center> </p>
    </body> 
    </html>"
  
  dlg1.set_html  html_string1
  
  dlg1.set_size 600,400
  dlg1.set_position 350,250
  
  dlg1.show_modal
end


#===============================================================================================
#Toolbar

dr_di_toolbar = UI::Toolbar.new $lddStrings.GetString("Driving Dimensions")

cmd_tool = UI::Command.new($lddStrings.GetString("Driving Dimensions")) {Sketchup.active_model.select_tool Driving_Dimensions_Tool.new}  
                                                                           
cmd_tool.small_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_tool.png")
cmd_tool.large_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_tool.png")
cmd_tool.tooltip = $lddStrings.GetString("Driving Dimensions Tool")
cmd_tool.status_bar_text = $lddStrings.GetString("Select Driving Dimensions Tool")
cmd_tool.menu_text = $lddStrings.GetString("Driving Dimensions")

cmd_tool.set_validation_proc {ldd_tool_validation_proc()}

dr_di_toolbar = dr_di_toolbar.add_item cmd_tool


# add to langhandler//
cmd_fixation_tool = UI::Command.new($lddStrings.GetString("Driving Dimensions Fixation Tool")) {Sketchup.active_model.select_tool Driving_Dimensions_Fixation_Tool.new} 
cmd_fixation_tool.small_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_fixation.png")
cmd_fixation_tool.large_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_fixation.png")
cmd_fixation_tool.tooltip = $lddStrings.GetString("Driving Dimensions Fixation Tool")
cmd_fixation_tool.status_bar_text = $lddStrings.GetString("Select Driving Dimensions Fixation Tool")
cmd_fixation_tool.menu_text = $lddStrings.GetString("Driving Dimensions Fixation Tool")

cmd_fixation_tool.set_validation_proc {ldd_fixation_tool_validation_proc()}

dr_di_toolbar = dr_di_toolbar.add_item cmd_fixation_tool


cmd_recalculate = UI::Command.new($lddStrings.GetString("Recalculate Driving Dimensions")) {ldd_recalculate_model()} 
cmd_recalculate.small_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_recalculate.png")
cmd_recalculate.large_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_recalculate.png")
cmd_recalculate.tooltip = $lddStrings.GetString("Recalculate Model With Driving Dimensions")
cmd_recalculate.status_bar_text = $lddStrings.GetString("Recalculate Model With Driving Dimensions")
cmd_recalculate.menu_text = $lddStrings.GetString("Recalculate Driving Dimensions")

dr_di_toolbar = dr_di_toolbar.add_item cmd_recalculate

cmd_hide_show = UI::Command.new($lddStrings.GetString("Hide/Show Driving Dimensions")) {ldd_hide_show()} 
cmd_hide_show.small_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_hide_show.png")
cmd_hide_show.large_icon = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_hide_show.png")
cmd_hide_show.tooltip = $lddStrings.GetString("Hide/Show Driving Dimensions")
cmd_hide_show.status_bar_text = $lddStrings.GetString("Hide/Show Driving Dimensions")
cmd_hide_show.menu_text = $lddStrings.GetString("Hide/Show Driving Dimensions")

cmd_hide_show.set_validation_proc {ldd_hide_show_validation_proc()}

dr_di_toolbar = dr_di_toolbar.add_item cmd_hide_show

dr_di_toolbar.show


#===============================================================================================


#-----------------------------------------------------------------------------------------------
Sketchup.add_observer(LDDAppObserver.new)
Sketchup.active_model.addLDDObservers()
#-----------------------------------------------------------------------------------------------
if( not file_loaded?("ldd.rb"))

  mod = Sketchup.active_model		   
  UI.add_context_menu_handler do |menuBig|
  
    menuBig.add_separator
    menu = menuBig.add_submenu "Driving Dimensions"
    #menuBig.add_separator

    
    submenu = menu.add_submenu  $lddStrings.GetString("Driving Dimensions Solve Mode")    
    
    submenu.add_item ("current = " + (LDDConstraint.immediatelySolve ? "Immediately" : "By command")) {}
    submenu.add_separator
    
    submenu.add_item ($lddStrings.GetString("Immediately")) {LDDConstraint.immediatelySolve= true }
    submenu.add_item ($lddStrings.GetString("By command")) {LDDConstraint.immediatelySolve= false }
   
   #-----------------------------------------------------------------------------------------------

    menu.add_item($lddStrings.GetString("Remake Driving Dimensions labels")){ldd_remake_labels(Sketchup.active_model)}      

  #-----------------------------------------------------------------------------------------------
  if (ENV['LDD_DEV'] == "TRUE")
    mod = Sketchup.active_model		   
        #menu.add_separator
        submenu = menu.add_submenu "Driving Dimensions mode"      
        mode1 = mod.get_attribute "LDDAttributes", "mode", nil
        mode_n =  (ldd_mode_name(mode1)).to_s
        submenu.add_item ("current = " + mode_n) {}
        submenu.add_separator
        submenu.add_item ("VxE_VxF_ExF") {mod.set_attribute "LDDAttributes", "mode", 54}
        submenu.add_item ("VxE_VxF") {mod.set_attribute "LDDAttributes", "mode", 52}
        submenu.add_item ("VxE_ExF") {mod.set_attribute "LDDAttributes", "mode", 51}
        submenu.add_item ("VxF_ExF") {mod.set_attribute "LDDAttributes", "mode", 53}
  end
    submenu = menu.add_submenu "Distance or Angle"      
    submenu.add_item ("current = " + (LDDConstraint.setAngleForParallelEdges ? "Angle" : "Distance")) {}
    submenu.add_separator      
    submenu.add_item ("Angle") {LDDConstraint.setAngleForParallelEdges= true}
    submenu.add_item ("Distance") {LDDConstraint.setAngleForParallelEdges= false}

  #-----------------------------------------------------------------------------------------------

    selection = Sketchup.active_model.selection    
    if (selection)      
      if (selection.length < 30)        
        restrArray = []
        
        selection.each{ |sel|
          if(sel.kind_of? Sketchup::Text)
            id = sel.get_attribute "LDDGUIAttributes", "Driving_Dimension", 0
            constraint = LDDConstraint.constraints.findConstraintOnID(id)
            if constraint
              restrArray.push constraint
            end
          end
        } 
        if (restrArray[0])          
          menu.add_item($lddStrings.GetString("Remove Driving Dimension")){ LDDConstraint.constraints.removeConstraint(restrArray[0]) }
          menu.add_item($lddStrings.GetString("Hide Driving Dimension")){(restrArray[0]).drivingDimensionEntity.visible= false }
        end        
      end
    end
  end
  


  #-----------------------------------------------------------------------------------------------


  help_menu = UI.menu("Help")  
  help_menu.add_separator  
  
  image = (Sketchup.find_support_file("\Plugins") + "/ldd/Dr_di_tool.png")
  
  dlg = UI::WebDialog.new("About Driving Dimensions", false, nil, 600, 400, 350, 250, false);  
  dlg.set_size 600, 400
  dlg.set_position 350, 250
    
   html_string =
    "<html> 
    <head> 
      <title> About Driving Dimensions</title>      
    </head>
    <body bgcolor =	D4D0C8> 
       <p> <center> <img src=\" "+ image +"\"  alt=\"Picture\"> </center> </p>
       <p> <center> <b> <big> <big> <big> Driving Dimensions </big> </big> </big> </b> </center> </p>
       <p> <center> Version " + LEDAS_DRIVING_DIMENSIONS_VERSION.to_s + "</center> </p>
       <p> <center> Build " + LEDAS_DRIVING_DIMENSIONS_BUILD.to_s + "</center> </p>       
       <p> <center> <a href=\"http://drivingdimensions.com\" target= \"_blank\"> 
                                                        www.DrivingDimensions.com </a> </center> </p>
       <p> <center> <big> (c) 2008 LEDAS Ltd. </big> </center> </p>
    </body> 
    </html>"
    
      
  dlg.set_html  html_string  
    
  help_menu.add_item ($lddStrings.GetString("About Driving Dimensions")) {dlg.show_modal ; dlg.set_size 600, 400; dlg.set_position 350, 250}
  
  help_url = "http://drivingdimensions.com/SketchUp/help.php"
  help_menu.add_item ($lddStrings.GetString("Driving Dimensions Help")) {UI.openURL(help_url)}
  
  tutorials_url = "http://drivingdimensions.com/SketchUp/videos.php"
  help_menu.add_item ($lddStrings.GetString("Driving Dimensions Video Tutorials")) {UI.openURL(tutorials_url)}
  
  help_menu.add_separator    


  #-----------------------------------------------------------------------------------------------

  tools_menu = UI.menu("Tools")  
  #tools_menu.add_separator  
  utilities_menu = tools_menu.add_submenu($lddStrings.GetString("Driving Dimensions"))
  utilities_menu.add_item cmd_tool  
  utilities_menu.add_item cmd_fixation_tool  
  utilities_menu.add_item cmd_recalculate
  utilities_menu.add_item cmd_hide_show
end
#-----------------------------------------------------------------------------------------------

file_loaded("ldd.rb")
