# SketchUp to DXF converter 
# Last edited: 29 dec 2008
# Author: Tomas Princ, based on the DXF exporter of Nathal Bromham
# Vers          Date            Author             Description
# 1.0.1          31122008     T.Princ             2. Doplneni odchytavani chyb
# 1.0.0          29122008     T.Princ             1. Vytvoreni pluginu

require 'sketchup.rb'

def export_file ( dim )
  begin
    file_type = "dxf"
    if (file_type == "dxf")
      model = Sketchup.active_model
      ss = model.selection
      entities = model.entities
      $ent_array = []
      model.start_operation "export_dxf"
      if ss.empty? 
        answer = UI.messagebox("No objects selected. Export entire model?", MB_YESNOCANCEL)
      else
        export_ents = Sketchup.active_model.selection

      end
      
      if( answer == 6 )
        export_ents = model.entities
      end
      soft = UI.messagebox("Include soft edges?", MB_YESNO)
      if( answer == 6 ) or (not ss.empty?)
        out_name = UI.openpanel( file_type+" file location", "." , "#{File.basename(model.path).split(".")[0]}." +file_type)
        ent_file = File.new( out_name , "w" )
        others = 0       
        i = 0
        0.upto(export_ents.length - 1) do |e|
          element = export_ents[i]
	      if (element.typename == "Edge")
          if (not element.soft? or (element.soft? and soft == 6))	        
	          $ent_array.push element
	        end
	      end
          i = i + 1
        end
        (export_ent ent_file, dim )
      end
      model.commit_operation
    end
  rescue       # Error
    UI.messagebox("Error: " + $!, MB_OK)
    else
    UI.messagebox("DXF file has been created", MB_OK)
  end
end


def export_ent( dxf_file, dim )
  begin
    fixz = "0"
    koef = 25.4
    model = Sketchup.active_model
    model_filename = File.basename(model.path)
    if( model_filename == "" )
      model_filename = "no_name"
    end
    model_name = model_filename.split(".")[0]
    dxf_file.puts( " 0")
    dxf_file.puts( "SECTION")
    dxf_file.puts( " 2")
    dxf_file.puts( "ENTITIES")
    $ent_array.each do |tri|
      dxf_file.puts( "  0")
      dxf_file.puts( "LINE")
      dxf_file.puts( "  8")
      dxf_file.puts( "0")
      dxf_file.puts( 10)#x
      dxf_file.puts(tri.start.position.x.to_f*koef)
      dxf_file.puts( 20)#y
      dxf_file.puts(tri.start.position.y.to_f*koef)
      dxf_file.puts( 30)#z  
     if (dim == "3d")
      dxf_file.puts(tri.start.position.z.to_f*koef)
     else
      dxf_file.puts(fixz.to_f)
     end 
      dxf_file.puts( 11)#x
      dxf_file.puts(tri.end.position.x.to_f*koef)
      dxf_file.puts( 21)#y
      dxf_file.puts(tri.end.position.y.to_f*koef)
      dxf_file.puts( 31)#z
     if (dim == "3d")   
      dxf_file.puts(tri.end.position.z.to_f*koef)
     else
      dxf_file.puts(fixz.to_f)
     end  
    end
    dxf_file.puts( "  0")
    dxf_file.puts( "ENDSEC")
    dxf_file.puts( "  0")
    dxf_file.puts( "EOF")
  rescue    # Pokud je chyba
    UI.messagebox("Error: " + $!, MB_OK)
  ensure   # Zavrit soubor musim vzdy, v teto metode je jiz otevreny
    dxf_file.close
  end
end

if( not file_loaded?("to_dxf.rb") )
  add_separator_to_menu("File")
  UI.menu("File").add_item("Export to 2D DXF") { export_file ( "2d" ) }
  UI.menu("File").add_item("Export to 3D DXF") { export_file ( "3d" ) }
end
file_loaded("to_dxf.rb")
